require 'nokogiri'

module Nokogiri
	module XML
		class Document
			def add_node_under_css_selector(css_selector, node)
				nodes = node.is_a?(Array) ? node : [node]
				self.css(css_selector).each { |n| nodes.each { |x| n.add_child(x) } }
			end

			def update_node_at_css_selector(css_selector, attributes={}, content={})
				attribute_exists = !attributes.nil? && attributes.any?
				content_exists = !content.nil? && content.any?
				self.css(css_selector).each { |n| 
					if attribute_exists
						attributes.each { |k,v| n[k.to_s] = v}
					end
					if content_exists
						n.content = content
					end  
				}
			end
		end
	end
end

module QuiversTaskrunner
	module XmlHelper

		def self.get_xml(filepath)
			xml = nil
			File.open(filepath, "rb") do |f|
				xml = Nokogiri::XML(f)
			end
			return xml
		end

		def self.overide_xml(filepath, xml)
			File.open(filepath, "w") do |f|
				f.write(xml.to_xml)
			end
		end

		def self.create_xmlnode(name, original_document, attributes={}, content={})
			node = Nokogiri::XML::Node.new name, original_document
			unless attributes.nil? || attributes.empty?
				attributes.each { |k,v|
					node[k.to_s] = v
				}
			end
			unless content.nil? || content.empty?
				node.content = content
			end
			return node
		end
	end
end